diff --git a/src/hirlite.c b/src/hirlite.c
index b2c9eb5..e751d21 100644
--- a/src/hirlite.c
+++ b/src/hirlite.c
@@ -1642,11 +1642,11 @@ static void hsetGenericCommand(rliteClient *c, int update) {
 	size_t fieldlen = c->argvlen[2];
 	unsigned char *value = UNSIGN(c->argv[3]);
 	size_t valuelen = c->argvlen[3];
-	long added;
+	long added = 0;
 
 	int retval;
 	retval = rl_hset(c->context->db, key, keylen, field, fieldlen, value, valuelen, &added, update);
-	RLITE_SERVER_OK(c, retval);
+	RLITE_SERVER_ERR2(c, retval, RL_OK, RL_FOUND);
 	c->reply = createLongLongObject(added);
 
 cleanup:
diff --git a/tests/hash-test.c b/tests/hash-test.c
index d8090f5..0806440 100644
--- a/tests/hash-test.c
+++ b/tests/hash-test.c
@@ -38,6 +38,7 @@ TEST test_hsetnx() {
 	rliteFreeReplyObject(reply);
 
 	char *argv3[100] = {"hget", "mykey", "myfield", NULL};
+	reply = rliteCommandArgv(context, populateArgvlen(argv3, argvlen), argv3, argvlen);
 	EXPECT_REPLY_STR(reply, "mydata", 6);
 	rliteFreeReplyObject(reply);
 
@@ -421,6 +422,7 @@ TEST test_hmget() {
 SUITE(hash_test)
 {
 	RUN_TEST(test_hset);
+	RUN_TEST(test_hsetnx);
 	RUN_TEST(test_hget);
 	RUN_TEST(test_hexists);
 	RUN_TEST(test_hdel);
